package utility;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.Arrays;

import org.eclipse.paho.client.mqttv3.MqttException;
import org.json.JSONException;
import org.json.JSONObject;

import scenari.Automa;
import scenari.Scenari;

public class Esecutore extends Thread {

//	private MyQueue<Integer> codaVal; // coda in cui vengono mantenuti i valori da sommare alla variabile valore
//	private int valore; // variabile numerica cumulativa inizialmente impostata a 0
//	public final int SOGLIA = 100;
//	private Publisher publisher;
	private Automa automa;
	private Scenari scenari;
//	private String outputSuono; // nome logico dell'interruttore che fa scattare il suono dell'allarme 

	public Esecutore(/* Publisher publisher, MyQueue<Integer> codaVal, */ Automa automa,Scenari scenari) {
//		this.codaVal = codaVal;
//		this.valore = 0;
		this.automa = automa;
//		this.publisher = publisher;
//		this.outputSuono = outputSuono;
		this.scenari = scenari;
	}
	
//	private int numeroRighe = 0;
	private boolean isDonePublishing = false;
	private int retryNum = 0;
	private int filesNum = 0;

	public void run() {
//		qui ci va la business logic
		try {
			while (true) {
				LocalTime ora = LocalTime.now();
//				if(!automa.waitForAntifurto())
				boolean unreadStatus = automa.unreadStatus;
//				if(retryNum < filesNum || unreadStatus)
//					System.out.println("will we skip? "+ automa.getAntifurto()  +" {o.o} "+ unreadStatus+" {o.o} "+  isDonePublishing +" {o.o} "+ (unreadStatus && automa.getAntifurto()) +" {o.o} "+ (!unreadStatus && automa.getAntifurto() && isDonePublishing));
				if((unreadStatus && automa.getAntifurto())//se leggo lo stato per la prima volta e l'antifurto e' attivo -> ciclo
						|| (!unreadStatus && automa.getAntifurto() && isDonePublishing))//se ho gia' letto lo stato e l'antifurto e' attivo e devo ancora pubblicare -> ciclo
					continue;
//				else isDonePublishing = false;
				// l’antifurto è acceso
				FileReader fr = randomFileScenari();
//				System.out.println("do we have a file? "+(fr != null));
				if(fr == null)//|| numeroRighe == 0)
					continue;
				BufferedReader br = new BufferedReader(fr);// selezioniamo un file contenente i comandi
				String line = br.readLine();//su ogni linea si trova un nuovo comando, in ordine di tempo dal meno recente al piu' recente
//				numeroRighe--;
				while(line != null && line.isBlank()) {
					line = br.readLine();
//					numeroRighe--;
				}
				LocalTime tempoCmd = LocalTime.now();
				boolean startedPublishing = false;
//				String nomeLuce;
//				String cmd;
//				System.out.println("is entering? "+(line != null && (!isDonePublishing || ora.isBefore(tempoCmd))));
				while(line != null && (!isDonePublishing || ora.isBefore(tempoCmd))) {
					ora = LocalTime.now();
//					System.out.println("\tsecondo ciclo");
					
					JSONObject jline = new JSONObject(line);
					String[] time = jline.getString("tempo").split("-");
//					System.out.println("using: "+line);
					if(time.length != 3) {
//						System.out.println(jline.getString("tempo"));
						continue;
					}
					tempoCmd = LocalTime.of(Integer.valueOf(time[0]), Integer.valueOf(time[1]), Integer.valueOf(time[2]));// otteniamo [la data e] l’ora in cui è stato inviato quel comando

					LocalTime tempoAttuale = LocalTime.now();
					try {
						long waitingTime = Helper.timeDifference(tempoAttuale, tempoCmd)*1000;
						if(waitingTime > 0) {
//							System.out.println(tempoAttuale);
//							System.out.println(tempoCmd);
//							System.out.println("Waiting to execute command");
//							long offset = ((Double) (Math.random() * 10)).intValue()*1000;//trova un valore tra 1 e 10 (*1000)
							//ThreadLocalRandom.current().nextLong(10000);
//							if(offset%2 == 0) {
//								waitingTime += offset;// + 1000;
//							} else waitingTime -= offset;
//							waitingTime += 1000;
//							System.out.println(waitingTime);
							if(waitingTime > 1000)
								Thread.sleep(waitingTime);
							
//							System.out.println("running...");
							startedPublishing = true;
//							System.out.println("\tpublishing");
							String nomeLuce = jline.getString("luce");
							String cmd = jline.getString("cmd");
//							System.out.println("to/gruppo2/luci/gpio/"+nomeLuce);
//							System.out.println("{cmd:"+cmd+"}");
//							publisher.aggiungiComando("to/gruppo2/luci/gpio/"+nomeLuce, "{cmd:"+cmd+"}");
							scenari.sendMqttMessage("to/gruppo2/luci/gpio/"+nomeLuce, "{cmd:"+cmd+"}");
						} //else System.out.println("useless");
					} catch (InterruptedException | MqttException e) {
						e.printStackTrace();
					}
					line = br.readLine();
//					numeroRighe--;
					if(line != null)
						while(line.isBlank()) {
							line = br.readLine();
	//						numeroRighe--;
						}
					else isDonePublishing = true;
//					System.out.println("should restart? "+line != null+" ; "+ora.isBefore(tempoCmd));
//					System.out.println(line != null && ora.isBefore(tempoCmd));
//					System.out.println("should restart? "+(line != null && (!isDonePublishing || ora.isBefore(tempoCmd))));
//					System.out.println(startedPublishing);
				}
//				now line == null so I'm done reading the file
//				TODO something about this
				br.close();
				fr.close();
//				System.out.println("Retries: "+retryNum+" ; "+filesNum);
				retryNum++;
				isDonePublishing = (startedPublishing && retryNum < filesNum);//if i havent published, I should retry
//				System.out.println("started? "+startedPublishing+" [O.O] "+isDonePublishing);
//				numeroRighe = 0;
			}
		} catch (IOException | JSONException e) {
			e.printStackTrace();
		}
	}
	
	private ArrayList<File> filesRead = new ArrayList<File>();

	private FileReader randomFileScenari() throws IOException {
		// Creating a File object for directory
		File directoryPath = new File("./db-scenari/");
		// List of all files and directories
		final ArrayList<File> filesListRaw = new ArrayList<File>(Arrays.asList(directoryPath.listFiles()));
		final ArrayList<File> filesList = new ArrayList<File>();
		for(File f : filesListRaw) {
			if(f.toString().endsWith(".json"))
				filesList.add(f);
		}
		filesNum = filesList.size();
		if(filesNum == 0)
			return null;
		if(filesNum == 1) {
			File f = filesList.get(0);
//			numeroRighe = ((Long)(Files.lines(f.toPath()).count())).intValue();
			filesRead.add(f);
			return new FileReader(f);
		}
		File chosenFile = null;
		do {
			chosenFile = filesList.get(((Double) (Math.random() * filesNum)).intValue());
		} while(chosenFile == null || filesRead.contains(chosenFile));
		filesRead.add(chosenFile);
		return new FileReader(chosenFile);
	}

}
